(function( $ ){
  $.fn.dotNavigation = function(options) {
	
  	var settings={
		'widthContainer':300,
		'noIcons': 4,
		'numIconsInRow':2,
		'marginIcon':5,
		'borderIcon':1,
		'borderIconColor':'black',
		'paddingIcon':0,
		'paddingBottomIcon':0,
		'aspectRatio':1
	};
    
	return this.each(function() {        
	   // If options exist, lets merge them with default settings
		if ( options ) { 
			$.extend( settings, options );
	    }
		
	    // Do your awesome plugin stuff here
		var totalElements = $(this).find('.slide-container').find('a').length;
		var numPages = Math.ceil(totalElements/settings.noIcons);
		var j=0;
		var listATags = $(this).find('.slide-container').find('a');
		$(this).find('.slide-container').empty();		
		for(var i=0;i<numPages;i++){
			$(this).find('.dot-navigation').append('<span id="page-'+i+'" class="page-nav"><img src="images/nselected.png"></span>');
			$(this).find('.slide-container').append('<li id="pagelink-'+i+'" class="album-link"></li>');
			var liElement = $(this).find('.slide-container').find('li#pagelink-'+i);
			liElement.append('<div class="page"></div>');
			for(var cnt=0;cnt<settings.noIcons;cnt++){
				liElement.find('.page').append(listATags.get(j));
				j++;
				if(j==totalElements)
					break;
			}
		}
		$(this).find('.slide-container').find('li#pagelink-0').removeClass('album-link').addClass('current-album-link');
		$(this).find('.dot-navigation').find('span#page-0').removeClass('page-nav').addClass('current-page-nav');
		$(this).find('.dot-navigation').find('span#page-0').find('img').attr("src","images/selected.png");

		//set the CSS values
		var widthIcons = (settings.widthContainer-(settings.numIconsInRow*((2*settings.paddingIcon)+(2*settings.borderIcon)+(2*settings.marginIcon))))/settings.numIconsInRow;
		var heightIcons = (widthIcons)/settings.aspectRatio;		
		$(this).find('.slide-container').find('a').css("width",widthIcons);
		$(this).find('.slide-container').find('a').css("height",heightIcons);
		$(this).find('.slide-container').find('a').find('img').css("width",widthIcons);
		$(this).find('.slide-container').find('a').find('img').css("height",heightIcons);
		$(this).find('.slide-container').find('a').css("margin",settings.marginIcon);
		$(this).find('.slide-container').find('a').css("border-width",settings.borderIcon);
		$(this).find('.slide-container').find('a').css("padding",settings.paddingIcon);
		$(this).find('.slide-container').find('a').css("padding-bottom",settings.paddingBottomIcon);
		$(this).find('.slide-container').find('a').css("border-color",settings.borderIconColor);
		var widthSlideRunner = settings.numIconsInRow*((2*settings.paddingIcon)+(2*settings.marginIcon)+(2*settings.borderIcon)+widthIcons);
		var noVerticalIcon = Math.ceil(settings.noIcons/settings.numIconsInRow);
		var heightSlideRunner = noVerticalIcon * ((2*settings.marginIcon)+(2*settings.borderIcon) + heightIcons + settings.paddingIcon + settings.paddingBottomIcon);
		$(this).find('.slide-runner').css("width",widthSlideRunner);
		$(this).find('.slide-runner').css("height",heightSlideRunner);
		
		var sizeContainer = numPages*widthSlideRunner;
		$(this).find('.slide-container').css("width",sizeContainer);
		$(this).find('.slide-container').find('.page').css("width",widthSlideRunner);
		$(this).find('.slide-container').find('.page').css("height",heightSlideRunner);
		$(this).css("width",widthSlideRunner);
		$(this).css("height",(heightSlideRunner+40));
		//End Setting CSS values
		
		$('.dot-navigation span').click(function() {
		 	var currentLi=$('div#photoAlbum').find('ul').find('li.current-album-link');
			var b=""+currentLi.attr('id');
			var len=b.length;
			var ind=b.indexOf('-');
			var curLink=parseInt(b.substring(ind+1,len));

			var temp=$(this).attr('id');
			len=temp.length;
			ind=temp.indexOf('-');
			var pageRequest=parseInt(temp.substring(ind+1,len));
			if(curLink==pageRequest){
			}else{
				$('div#photoAlbum').find('ul').find('li.current-album-link').removeClass('current-album-link').addClass('album-link');
				$('div#photoAlbum').find('ul').find('li#pagelink-'+pageRequest).removeClass('album-link').addClass('current-album-link');
				$('div#photoAlbum').find('.dot-navigation').find('span.current-page-nav').removeClass('current-page-nav').addClass('page-nav').find('img').attr("src","images/nselected.png");
				$('div#photoAlbum').find('.dot-navigation').find('span#page-'+pageRequest).removeClass('page-nav').addClass('current-page-nav').find('img').attr("src","images/selected.png");

				var diff=pageRequest-curLink;
				var abs=Math.abs(diff);
				var animationSpeed;
				if(abs>1)
					animationSpeed=100;
				else
					animationSpeed=500;
				var expression;
				if(diff>0){
					shiftLeft=widthSlideRunner*abs;
					expression='-='+shiftLeft;
					//console.log(widthSlideRunner,abs);
				}
				else{
					shiftLeft=widthSlideRunner*abs;
					expression='+='+shiftLeft;
					//console.log(widthSlideRunner,abs);
				}
				$('.slide-container li').stop(true,true).animate({
                    left: expression
                }, animationSpeed, function() {
                    // Animation complete.
					
					//console.log($(this).position());
                });	
			}
		});
		
		
		
		
	});
	
	
	};
})( jQuery );
